<?php
namespace Ecommerce\Services;

use Zeedhi\Framework\DTO;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class PedidoExportacaoService {

    protected $entityManager;
    protected $environment;

    public function __construct(EntityManager $entityManager, $environment) {
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
    }
    
    public function exportacao($row) {
        try {
            $this->entityManager->beginTransaction();
            $sql = "SELECT CDPRODUTO, CDMARCA, VRPRECUNIPRMARC FROM PRMARCPEDCOL WHERE CDFILIAL = :P_CDFILIAL AND NRPEDIDOCOL = :P_NRPEDIDOCOL";
            $stmt = $this->entityManager->getConnection()->prepare($sql);
            
            $resultProdutosOrigem = $stmt->execute(
                array(
                    "P_CDFILIAL"       => $row["CDFILIAL"],
                    "P_NRPEDIDOCOL"    => $row["NRPEDIDOCOLORIGEM"]
                    )
            );
            $resultProdutosOrigem = $stmt->fetchAll();
            foreach ($resultProdutosOrigem as $result) {
                $sql = "SELECT I.CDFILIAL, I.NRPEDCOLETA, I.CDFORNECED, I.CDPRODUTO, I.CDMARCA, I.CDREGIAO, P.CDFILIAL||P.NRPEDIDOCOL AS PRMARC FROM PEDCOLETA P, ITEMPEDCOL I WHERE P.CDFILIAL||P.NRPEDIDOCOL||P.CDOPERADOR = :P_CHAVE AND P.CDFILIAL = I.CDFILIAL AND P.NRPEDCOLETA = I.NRPEDCOLETA AND P.CDFORNECED = I.CDFORNECED AND P.CDREGIAO = I.CDREGIAO AND I.CDPRODUTO = :P_CDPRODUTO AND I.CDMARCA = :P_CDMARCA";
                $stmt = $this->entityManager->getConnection()->prepare($sql);
                
                $resultProdutosDestino = $stmt->execute(
                    array(
                        "P_CHAVE"      => $row["CHAVE"],
                        "P_CDPRODUTO"  => $result["CDPRODUTO"],
                        "P_CDMARCA"    => $result["CDMARCA"]
                    )    
                );
                $resultProdutosDestino = $stmt->fetchAll();
                if ($resultProdutosDestino != null) {
                    $sql = "UPDATE ITEMPEDCOL SET VRITEMPEDCOL = :P_VRPRECUNIPRMARC WHERE CDFILIAL = :P_CDFILIAL AND NRPEDCOLETA = :P_NRPEDCOLETA AND CDFORNECED = :P_CDFORNECED AND CDREGIAO = :P_CDREGIAO AND CDPRODUTO = :P_CDPRODUTO AND CDMARCA = :P_CDMARCA";
                    $stmt = $this->entityManager->getConnection()->prepare($sql);
                    $agoravai = $stmt->execute(
                        array(
                            "P_VRPRECUNIPRMARC"  => $result["VRPRECUNIPRMARC"],
                            "P_CDFILIAL"         => $resultProdutosDestino[0]["CDFILIAL"],
                            "P_NRPEDCOLETA"      => $resultProdutosDestino[0]["NRPEDCOLETA"],
                            "P_CDFORNECED"       => $resultProdutosDestino[0]["CDFORNECED"],
                            "P_CDREGIAO"         => $resultProdutosDestino[0]["CDREGIAO"],
                            "P_CDPRODUTO"        => $resultProdutosDestino[0]["CDPRODUTO"],
                            "P_CDMARCA"          => $resultProdutosDestino[0]["CDMARCA"]
                        )
                    );
                    $sql = "UPDATE PRMARCPEDCOL SET VRPRECUNIPRMARC = :P_VRPRECUNIPRMARC WHERE CDFILIAL||NRPEDIDOCOL = :P_PRMARC AND CDPRODUTO = :P_CDPRODUTO AND CDMARCA = :P_CDMARCA";
                    $stmt = $this->entityManager->getConnection()->prepare($sql);
                    $agoravaimesmo = $stmt->execute(
                        array(
                            "P_VRPRECUNIPRMARC"  => $result["VRPRECUNIPRMARC"],
                            "P_PRMARC"           => $resultProdutosDestino[0]["PRMARC"],
                            "P_CDPRODUTO"        => $resultProdutosDestino[0]["CDPRODUTO"],
                            "P_CDMARCA"          => $resultProdutosDestino[0]["CDMARCA"]
                            
                        )
                    );
                }
            }
                $this->entityManager->commit();
                $this->entityManager->flush();
            
        } catch (\Exception $e){
            $this->entityManager->rollBack();
            throw $e;
        }
    }
}